
PRO GET_VAR, vname,varu,titel,vsel,dist

  COMMON WIDGETobjects, base,read_button,select_button,$
               load_OBS,fit_OBS,plot_SED, $
               label0,label1,label2,label3,label4,label12, $
               combo_Mstar,combo_age,combo_Teff,combo_Lstar,combo_fUV, $
               combo_Mdisk,combo_Mdust,combo_dustgas,combo_Rin,combo_Rout, $
               combo_H0,combo_epsilon,combo_beta,combo_settle, $
               combo_amin,combo_amax,combo_apow,combo_dist,combo_incl, $
               fileSelect,fileExit,basenr,dataset1,dataset2,dataset3,$
               axisXselect,axisYselect,axisZselect,axisColours,axisFilters, $
               plotHist,plot2D,plot3D,save_gif,writeps,writedat,means2D, $
               contour2D,closeAll,combo_igas,text_ID,contourMod,gridNAME

  COMMON models, Nmod,Ngas,Nlam,Nincl1,Nincl2,idat1,idat2,idat3,Nobs,Ncont,Nline, $
               modelID, incl, age, Mdust, RinSave, alphaSED, ParaName, ParaVal,$
               lamcont, Fcont, incl1, incl2, lamobs, Fnuobs, beta_abs, $
               linenameobs, Flineobs, sigmaFnu, sigmaFl, bemcont, bemline, $
               LineName, LineFlux

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  COMMON selection, sel_models,sel_SEDs,sel_lines

  scale = 0
  type  = 1
  var   = !VALUES.F_NAN  
  ind = WHERE(strpos(ParaName,vname) GE 0,count)
  if (count EQ 1) then begin
    titel = vname
    var = fltarr(Nmod,Ngas)
    var(*,*) = ParaVal(ind,*,*)
  endif else if (count EQ 2) then begin
    ind = WHERE(ParaName EQ vname,count)
    if (count EQ 1) then begin
    titel = vname
    var = fltarr(Nmod,Ngas)
    var(*,*) = ParaVal(ind,*,*)
  endif else begin
    print,"*** no clear variable name", vname
    stop
  endelse
  endif  
  if (vname EQ "model_ID") then begin
    titel = "model_ID"
    var = modelID
  endif
  if (vname EQ "age") then begin
    titel = "age [Myr]"
    var = age
  endif
  if (vname EQ "Rin") then begin
    titel = "Rin [AU]"
    if (basenr EQ 3) then titel="Rin [Rsubli]"
    var = RinSave
  endif    
  if (strpos(vname,"Mdust") GE 0) then begin
    titel = "Mdust [Msun]"
    var = Mdust
  endif    
  if (vname EQ "alpha_SED") then begin
    titel = "alpha_SED"  ; 800-4000mic
    var = alphaSED
    type = 3
  endif  
  if (vname EQ "beta_abs") then begin
    titel = "beta_abs"  ; 800-4000mic
    var = beta_abs
  endif  
  ind = WHERE(strpos(LineName,vname) GE 0, count)
  if (count EQ 1) then begin
    titel = LineName(ind)
    var = fltarr(Nmod,Ngas,Nincl2)
    var(*,*,*) = LineFlux(ind,*,*,*)
    type  = 2
    scale = 1
    if (strpos(vname,"H2O_538") GE 0) then var(WHERE(var GT 1.E-17))=0.0 
    if (strpos(vname,"H2O_179") GE 0) then var(WHERE(var GT 3.E-16))=0.0
    if (strpos(vname,"H2O_180") GE 0) then var(WHERE(var GT 3.E-16))=0.0
    if (strpos(vname,"CO_2600") GE 0) then titel="CO 1->0 [W/m2]"
    if (strpos(vname,"CO_1300") GE 0) then titel="CO 2->1 [W/m2]"
    if (strpos(vname,'13CO_1360') GE 0) then titel="!U13!NCO 2->1 [W/m2]"
    if (strpos(vname,'C18O_1365') GE 0) then titel="C!U18!NO 2->1 [W/m2]"
    if (strpos(vname,"CO_867") GE 0)  then titel="CO 3->2 [W/m2]"
    if (strpos(vname,"CO_144") GE 0)  then titel="CO 19->18 @ 144.8mic [W/m2]"
    if (strpos(vname,"CO_90") GE 0)   then titel="CO 29->28 @ 90.2mic [W/m2]"
    if (strpos(vname,"CO_79") GE 0)   then titel="CO 33->32 @ 79.4mic [W/m2]" 
    if (strpos(vname,"CO_72") GE 0)   then titel="CO 36->35 @ 72.8mic [W/m2]"
    if (strpos(vname,"CII_157") GE 0) then titel="[CII] 157.7 [W/m2]"
    if (strpos(vname,"OI_63") GE 0)   then titel="[OI] 63.2 [W/m2]"
    if (strpos(vname,"OI_145") GE 0)  then titel="[OI] 145.5 [W/m2]"
  endif
  i1=strpos(vname,"Fcont")
  i2=strpos(vname,"mic")
  if ((i1 GE 0) AND (i2 GT i1)) then begin
    titel = vname+" [Jy]"
    reads,strmid(vname,i1+6,i2-i1-6),searchlam
    for i=0,Nlam-1 do begin
      if(lamcont(i) GT searchlam) then break
    endfor
    i=MAX([i,1])
    i=MIN([i,Nlam-1])
    fac=ALOG(searchlam/lamcont(i-1))/ALOG(lamcont(i)/lamcont(i-1))
    var=EXP((1.0-fac)*ALOG(Fcont(*,*,i-1))+fac*ALOG(Fcont(*,*,i)))
    type  = 3
    scale = 1
  endif  
  if (vname EQ "incl") then begin
    incl = fltarr(Nmod,Nincl1)
    id=0L
    repeat begin
      for j=0,Nincl1-1 do begin
        incl(id,j) = incl1(j)
      endfor
      id = id+1
    endrep until (id EQ Nmod)
    var = incl
    type = 3
    titel = "inclination [deg]"    
  endif
  if (~FINITE(var(0))) then begin
    print,"*** assignment of variable "+vname+" failed."
    stop
  endif  
  
  ;--------------------------------------------
  ; ***  put variable on unique dimensions  ***
  ;--------------------------------------------
  varu = fltarr(Nmod,Ngas,Nincl1)
  vsel = intarr(Nmod,Ngas,Nincl1)

  ; --- search for best matching line/cont inclinations ---
  kbest=intarr(Nincl1)
  for k=0,Nincl1-1 do begin
    qbest=9.e+29
    for j=0,Nincl2-1 do begin
      qual=ABS(incl1(k)-incl2(j))
      if (qual LT qbest) then begin
        qbest=qual
        kbest(k)=j
      endif
    endfor
    ;print,k,incl1(k),kbest(k),incl2(kbest(k))
  endfor

  if (type EQ 1) then begin               ; model parameter
    i=0L
    repeat begin
      for j=0,Ngas-1 do begin
        varu(i,j,*)=var(i,j)
        vsel(i,j,*)=sel_models(i,j)
      endfor
      i=i+1
    endrep until (i EQ Nmod)
  endif
  if (type EQ 2) then begin               ; line Flux
    i=0L
    repeat begin
      for j=0,Ngas-1 do begin
        for k=0,Nincl1-1 do begin
          varu(i,j,k)=var(i,j,kbest(k))
          vsel(i,j,k)=sel_lines(i,j,kbest(k))
        endfor
      endfor
      i=i+1
    endrep until (i EQ Nmod)
  endif
  if (type EQ 3) then begin               ; cont Flux
    i=0L
    repeat begin
      for k=0,Nincl1-1 do begin
        varu(i,*,k)=var(i,k)
        vsel(i,*,k)=sel_SEDs(i,k)
      endfor
      i=i+1
    endrep until (i EQ Nmod)
  endif
  ; --- scale flux with distance ---
  if (scale EQ 1) then begin
    varu = varu*(140.0/dist)^2    ; scale flux with 1/dist^2
  endif

END
