
;--------------------------------------------
; ***  choose quantity for colour-coding  ***
;--------------------------------------------
PRO SELECT_COLOURS

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour, $
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset

  sel1 = WHERE(cname1 EQ varname)
  sel2 = WHERE(cname2 EQ varname)

  print,"select the quantity for colour-coding ..."
  selectbase = WIDGET_BASE(TITLE="change color for ...")
  label1 = WIDGET_LABEL(selectbase, VALUE='variable', $
                        XOFFSET=5, YOFFSET=5, /ALIGN_LEFT)
  label2 = WIDGET_LABEL(selectbase, VALUE='divided by ...', $
                        XOFFSET=155, YOFFSET=5, /ALIGN_LEFT)
  selectID1 = WIDGET_LIST(selectbase,VALUE=varname,$
                        SCR_XSIZE=120,SCR_YSIZE=180,$
                        XOFFSET=0,YOFFSET=25)
  selectID2 = WIDGET_LIST(selectbase,VALUE=varname,$
                        SCR_XSIZE=120,SCR_YSIZE=180,$
                        XOFFSET=150,YOFFSET=25)
  selectlog = CW_BGROUP(selectbase, ["lin","log"], /COLUMN, /EXCLUSIVE, $  
                        LABEL_TOP='lin/log', /FRAME,$
                        XOFFSET=290,YOFFSET=5)
  label3 = WIDGET_LABEL(selectbase, VALUE='# colours', $
                        XOFFSET=290, YOFFSET=100, /ALIGN_LEFT)  
  minedit = WIDGET_TEXT(selectbase,/EDITABLE,value=cminval, $
                        XSIZE=12, XOFFSET=1, YOFFSET=232)
  maxedit = WIDGET_TEXT(selectbase,/EDITABLE,value=cmaxval, $
                        XSIZE=12, XOFFSET=151, YOFFSET=232)
  selectncolour = WIDGET_COMBOBOX(selectbase, $
           VALUE=['1','2','3','4','5','6','7','8'], $
           XOFFSET=290, YOFFSET=120,SCR_XSIZE=55)
  selectdone = WIDGET_BUTTON(selectbase, VALUE='done', UVALUE= 'done', $
                        XOFFSET=290, YOFFSET=170,$
                        XSIZE=60,YSIZE=40)
  WIDGET_CONTROL, selectID1, SET_LIST_SELECT=sel1, SET_LIST_TOP=0
  WIDGET_CONTROL, selectID2, SET_LIST_SELECT=sel2, SET_LIST_TOP=0
  WIDGET_CONTROL, selectlog, SET_VALUE=clog
  WIDGET_CONTROL, selectncolour, SET_COMBOBOX_SELECT=ncolour-1
  WIDGET_CONTROL, selectbase, XSIZE=360,YSIZE=270,$
                  XOFFSET=0,YOFFSET=500, /Realize
  XMANAGER, 'xColour',selectbase, /NO_BLOCK  
END 


