;---------------------------------------------------------------
; ***  define quantities for filtering selection  ***
;---------------------------------------------------------------

PRO SELECT_FILTERS

  COMMON axis, axis,varname,filtername,Nvars,$
               selectbase,selectID1,selectID2,selectlog,selectdone,$
               xvar1,xvar2,yvar1,yvar2,zvar1,zvar2,xlog,ylog,zlog,$
               cname1,cname2,clog,ncolour,selectncolour,$
               minedit,maxedit,xminval,xmaxval,yminval,ymaxval, $
               zminval,zmaxval,cminval,cmaxval, $
               fvar1,fvar2,fvar3,fvar4,fmin1,fmax1,fmin2,fmax2, $
               fmin3,fmax3,fmin4,fmax4,select1,select2,select3, $
               select4,minedit1,maxedit1,minedit2,maxedit2, $
               minedit3,maxedit3,minedit4,maxedit4,selectreset


  print,"select variables for filtering model selection ..."
  sel1 = WHERE(fvar1 EQ filtername)
  sel2 = WHERE(fvar2 EQ filtername)
  sel3 = WHERE(fvar3 EQ filtername)
  sel4 = WHERE(fvar4 EQ filtername)
  mintext1 = fmin1
  maxtext1 = fmax1
  mintext2 = fmin2
  maxtext2 = fmax2
  mintext3 = fmin3
  maxtext3 = fmax3
  mintext4 = fmin4
  maxtext4 = fmax4
  selectbase = WIDGET_BASE(TITLE="select the filters ...")
  label1 = WIDGET_LABEL(selectbase, VALUE='variable 1', $
                        XOFFSET=10, YOFFSET=5, /ALIGN_LEFT)
  label2 = WIDGET_LABEL(selectbase, VALUE='variable 2', $
                        XOFFSET=150, YOFFSET=5, /ALIGN_LEFT)
  label3 = WIDGET_LABEL(selectbase, VALUE='variable 3', $
                        XOFFSET=290, YOFFSET=5, /ALIGN_LEFT)
  label4 = WIDGET_LABEL(selectbase, VALUE='variable 4', $
                        XOFFSET=430, YOFFSET=5, /ALIGN_LEFT)
  select1 = WIDGET_LIST(selectbase, VALUE=filtername, $
                        SCR_XSIZE=120, SCR_YSIZE=180, $
                        XOFFSET=5, YOFFSET=25)
  select2 = WIDGET_LIST(selectbase, VALUE=filtername, $
                        SCR_XSIZE=120, SCR_YSIZE=180, $
                        XOFFSET=145, YOFFSET=25)
  select3 = WIDGET_LIST(selectbase, VALUE=filtername, $
                        SCR_XSIZE=120, SCR_YSIZE=180, $
                        XOFFSET=285, YOFFSET=25)
  select4 = WIDGET_LIST(selectbase, VALUE=filtername, $
                        SCR_XSIZE=120, SCR_YSIZE=180, $
                        XOFFSET=425, YOFFSET=25)
  label5 = WIDGET_LABEL(selectbase, VALUE='min', $
                        XOFFSET=10, YOFFSET=215, /ALIGN_LEFT)
  label6 = WIDGET_LABEL(selectbase, VALUE='min', $
                        XOFFSET=150, YOFFSET=215, /ALIGN_LEFT)
  label7 = WIDGET_LABEL(selectbase, VALUE='min', $
                        XOFFSET=290, YOFFSET=215, /ALIGN_LEFT)
  label8 = WIDGET_LABEL(selectbase, VALUE='min', $
                        XOFFSET=430, YOFFSET=215, /ALIGN_LEFT)
  minedit1 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=mintext1, $
                          XSIZE=12,XOFFSET=5,YOFFSET=232)
  minedit2 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=mintext2, $
                          XSIZE=12,XOFFSET=145,YOFFSET=232)
  minedit3 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=mintext3, $
                          XSIZE=12,XOFFSET=285,YOFFSET=232)
  minedit4 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=mintext4, $
                          XSIZE=12,XOFFSET=425,YOFFSET=232)
  label9 = WIDGET_LABEL(selectbase, VALUE='max', $
                        XOFFSET=10, YOFFSET=272, /ALIGN_LEFT)
  label10 = WIDGET_LABEL(selectbase, VALUE='max', $
                        XOFFSET=150, YOFFSET=272, /ALIGN_LEFT)
  label11 = WIDGET_LABEL(selectbase, VALUE='max', $
                        XOFFSET=290, YOFFSET=272, /ALIGN_LEFT)
  label12 = WIDGET_LABEL(selectbase, VALUE='max', $
                        XOFFSET=430, YOFFSET=272, /ALIGN_LEFT)
  maxedit1 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=maxtext1, $
                          XSIZE=12,XOFFSET=5,YOFFSET=289) 
  maxedit2 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=maxtext2, $
                          XSIZE=12,XOFFSET=145,YOFFSET=289)
  maxedit3 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=maxtext3, $
                          XSIZE=12,XOFFSET=285,YOFFSET=289)
  maxedit4 = WIDGET_TEXT(selectbase,/EDITABLE,VALUE=maxtext4, $
                          XSIZE=12,XOFFSET=425,YOFFSET=289)
  selectreset= WIDGET_BUTTON(selectbase, VALUE='reset', $
                        XSIZE=50,YSIZE=30,XOFFSET=560,YOFFSET=172) 
  selectdone = WIDGET_BUTTON(selectbase, VALUE='done', UVALUE= 'done', $
                        XOFFSET=550, YOFFSET=279,$
                        XSIZE=70,YSIZE=40)
  WIDGET_CONTROL, select1, SET_LIST_SELECT=sel1
  WIDGET_CONTROL, select2, SET_LIST_SELECT=sel2
  WIDGET_CONTROL, select3, SET_LIST_SELECT=sel3
  WIDGET_CONTROL, select4, SET_LIST_SELECT=sel4
  WIDGET_CONTROL, selectbase, XSIZE=630,YSIZE=330,$
                  XOFFSET=0,YOFFSET=500, /Realize
  XMANAGER, 'xFilters',selectbase, /NO_BLOCK  
END 
