PRO READ_VAL,text,parameter,name

COMMON selection, sel_models, sel_SEDs, sel_lines

    if (STRPOS(text,'<=') NE -1) then begin
      tmp = STRMID(text,2)
      reads,tmp,val
      index = WHERE(parameter GT val, count)
      if (count NE 0) then sel_models(index) = 0
      print,"selection ", name, " <= ",val
    endif 
    if (STRPOS(text,'>=') NE -1) then begin
      tmp = STRMID(text,2)
      reads,tmp,val
      index = WHERE(parameter LT val, count)
      if (count NE 0) then sel_models(index) = 0
      print,"selection ", name, " >= ",val
    endif 
    if (STRPOS(text,'--')  NE -1) then begin
      ind = STRPOS(text,'--')
      tmp = STRMID(text,0,ind)                   
      reads,tmp,val1
      tmp = STRMID(text,ind+2)
      reads,tmp,val2
      if (val2 LT val1) then begin                ;make sure val1 < val2
        tmp  = val2
        val2 = val1
        val1 = tmp
      endif
      index = WHERE(parameter LT val1, count)
      if (count NE 0) then sel_models(index) = 0
      index = WHERE(parameter GT val2, count)
      if (count NE 0) then sel_models(index) = 0
      print,"selection ", name, val1, "   -", val2
    endif
    if (STRPOS(text,'<=') EQ -1 AND $
        STRPOS(text,'>=') EQ -1 AND $
        STRPOS(text,'--') EQ -1) then begin
      ;reads,text,val 
      if (valid_num(text,val) NE 1) then begin
        print,"*** SYNTAX ERROR for selection ",name," is ",text
        print,"*** please use number, <=number, >=number, or number1--number2"
        print
        return  
      endif  
      if (val EQ 0.0) then begin
        index = WHERE(parameter NE val, count)
      endif else begin
        index = WHERE(ABS(parameter/val-1.0) GT 1.E-6, count)
      endelse
      if (count NE 0) then sel_models(index) = 0
      print,"selection ", name, " = ",val
    endif  

END ; READ_VAL


